SystemOrganization addCategory: #'Summer2010-STdoc'!
SystemOrganization addCategory: #'Summer2010-Morph'!
SystemOrganization addCategory: #'Summer2010-Poland'!
SystemOrganization addCategory: #'Summer2010-BublingMorpg'!
SystemOrganization addCategory: #'Summer2010-JumpingJack'!
SystemOrganization addCategory: #'Summer2010-ObjVLisp'!

PluggableTextFieldMorph subclass: #MyOtherTextFieldMorph
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-JumpingJack'!

!MyOtherTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
container
	^ container! !

!MyOtherTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
container: anObject
	container := anObject! !

!MyOtherTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:23'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := self textMorphClass new with: self;
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!MyOtherTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^MyOtherTextMorphForFieldView! !

!MyOtherTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:23'!
vIsScrollbarNeeded

	^false.! !

!MyOtherTextFieldMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 22:20'!
with: aString container: aContainer
	|aPoint aColor|
	
	self container: aContainer.

	aPoint := self container topLeft.
	aColor := self container color.

	self
		setText: aString;
		width: ((self text asMorph width) +20);
		height: 8;
		borderColor: aColor;
		color: aColor negated;
		setTextColor: aColor.
		
! !

PluggableTextFieldMorph subclass: #MyTextFieldMorph
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-BublingMorpg'!

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 04:20'!
accept

	self setText: self text.! !

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 04:33'!
container
	^ container! !

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 04:33'!
container: anObject
	container := anObject! !

!MyTextFieldMorph methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 6/18/2010 20:04'!
delete

	self initialize.
	super delete.! !

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'sd 7/9/2010 13:35'!
resize
	|aPoint aString |
	aPoint := self container topLeft.
 	self width: ((self text asMorph width) +20).
	self container resize.! !

!MyTextFieldMorph methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 6/18/2010 05:18'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := self textMorphClass new with: self;
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!MyTextFieldMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/18/2010 04:58'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^MyTextMorphForFieldView! !

!MyTextFieldMorph methodsFor: 'scrolling' stamp: 'BenjaminVanRyseghem 6/18/2010 04:48'!
vIsScrollbarNeeded

	^false.! !

!MyTextFieldMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 20:18'!
with: aString container: aContainer
	|aPoint aColor|
	
	self container: aContainer.

	aPoint := self container topLeft.
	aColor := self container color.

	self
		setText: aString;
		width: ((self text asMorph width) +20);
		height: 8;
		borderColor: aColor;
		color: aColor negated;
		setTextColor: aColor.
		
! !

TestCase subclass: #CalcTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-Poland'!

!CalcTest methodsFor: 'as yet unclassified' stamp: 'sd 7/9/2010 13:26'!
testExecute

	self assert: (Calc execute: '+') = Calc error.
	self assert: (Calc execute: '3') = '3'.
	self assert: (Calc execute: '3 2 +') = '5'.
	self assert: (Calc execute: '3 2 + *') = Calc error.
	self assert: (Calc execute: '3 3 2 + *') = '15'.! !

!CalcTest methodsFor: 'as yet unclassified' stamp: 'sd 7/9/2010 13:26'!
testExecute2

	self assert: (Calc execute2: '+') = Calc error.
	self assert: (Calc execute2: '3') = '3'.
	self assert: (Calc execute2: '3 2 +') = '5'.
	self assert: (Calc execute2: '3 2 + *') = Calc error.
	self assert: (Calc execute2: '3 3 2 + *') = '15'.! !

!CalcTest methodsFor: 'as yet unclassified' stamp: 'sd 7/9/2010 13:26'!
testFinfFirstOperator

	self assert: (Calc findFirstOperator: #('3' '2' '+')) = 3.
	self assert: (Calc findFirstOperator: #('3' '3' '2' '+' '*')) = 4.
	self assert: (Calc findFirstOperator: #('3 2')) = Calc error.
	self assert: (Calc findFirstOperator: #('3 +')) = Calc error.! !

!CalcTest methodsFor: 'as yet unclassified' stamp: 'sd 7/9/2010 13:27'!
testParseStack

	self assert: (Calc parseStack: #('3' '2' '+')) = '5 '.
	self assert: (Calc parseStack: #('3' '3' '2' '+' '*')) = '3 5 * '.
	self assert: (Calc parseStack: #('3' '+')) = Calc error.
	self assert: (Calc parseStack: #('3' '2')) = Calc error.! !

!CalcTest methodsFor: 'as yet unclassified' stamp: 'sd 7/9/2010 13:27'!
testReturn

	self assert: (Calc return: '3') = '3'.
	self assert: (Calc return: '-') = Calc error.
	self assert: (Calc return: 'name:') = Calc error.! !

TestCase variableSubclass: #ObjExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-ObjVLisp'!

!ObjExampleTest classSide methodsFor: 'first user-defined metaclasses' stamp: ''!
setMetaclassDefinition
	"self setMetaclassDefinition"

	| setClass |
	setClass := Obj ObjClass
				send: #new
				withArguments: #(#(#name: #ObjSet #iv: #(#myInstances) #superclass: #ObjClass)).	"initialize on a metaclass"
	setClass 
		addMethod: #initialize
		args: 'initArray'
		withBody: 
			'
			objself binarySuper: #initialize with: initArray from: superClassOfClassDefiningTheMethod.
			objself send: #setIV
				withArguments: (Array with: #myInstances with: OrderedCollection new).
			objself'.

	setClass addUnaryMethod: #instances
		withBody: 'objself binarySend: #getIV with: #myInstances'.

	setClass addMethod: #new
		args: 'initArray'
		withBody: 
			'| newInst others |
			newInst := objself super: #new withArguments: (Array with: initArray) from: superClassOfClassDefiningTheMethod.
			others := objself unarySend: #instances.
			others := others add: newInst;
						yourself.
			objself send: #setIV withArguments: (Array with: #myInstances with: others).
			newInst'! !

!ObjExampleTest classSide methodsFor: 'first user-defined metaclasses' stamp: ''!
setMetaclassExample
	"self setMetaclassExample"

	| memoPointClass |
	self setMetaclassDefinition.
	memoPointClass := Obj ObjSet 
						send: #new
						withArguments: #(#(#name: #ObjMemoPoint 
									       #iv: #() #superclass: #ObjPoint)).
	memoPointClass send: #new withArguments: #(#(#x: 24 #y: 6)).
	memoPointClass send: #new withArguments: #(#(#x: 15 #y: 10)).
	memoPointClass debug.
	^memoPointClass unarySend: #instances! !

!ObjExampleTest methodsFor: 'setup' stamp: 'BenjaminVanRyseghem 7/11/2010 01:42'!
abstractMetaclassDefinition
 
	Obj createObjAbstract .
	! !

!ObjExampleTest methodsFor: 'setup' stamp: 'BenjaminVanRyseghem 7/11/2010 01:33'!
defineObjAbstractPoint

	(Obj giveClassNamed: #ObjAbstractClass)
		send: #new
		withArguments: #(#(#name: #ObjAbstractPoint #iv: #() #superclass: #ObjObject)).
	Obj ObjAbstractPoint
		addUnaryMethod: #givex
		withBody: 'objself  valueOfInstanceVariable: #x '.
	Obj ObjAbstractPoint 
		addUnaryMethod: #display
		withBody: 
			'Transcript cr;
				show: ''aPoint with x = ''.
			Transcript show: (objself unarySend: #givex) printString;
				cr'.! !

!ObjExampleTest methodsFor: 'setup' stamp: 'BenjaminVanRyseghem 7/11/2010 01:43'!
defineObjPoint
	
	Obj createObjPoint.! !

!ObjExampleTest methodsFor: 'setup' stamp: ''!
setUp

	Obj bootstrap.
	self abstractMetaclassDefinition.
	self defineObjAbstractPoint.
	self defineObjPoint! !

!ObjExampleTest methodsFor: 'test abstract' stamp: ''!
testAbstractMetaclassExample

	self should: [Obj ObjAbstractClass send: #new withArguments: #(#(#x: 24 #y: 6))] raise: Error.! !

!ObjExampleTest methodsFor: 'test abstract' stamp: ''!
testAbstractMetaclassExampleWithConcreteSubclass

	self shouldnt: [Obj ObjPoint send: #new withArguments: #(#(#x: 24 #y: 6))]
		raise: Error! !

!ObjExampleTest methodsFor: 'test abstract' stamp: 'BenjaminVanRyseghem 7/11/2010 02:06'!
testColoredPoint

	| coloredPointClass aColoredPoint |
	"add class definition here"
	coloredPointClass := Obj createObjColoredPoint.

	aColoredPoint := coloredPointClass send: #new withArguments: #((#x: 24 #y: 6 #color: #blue)).	
	"first messages sent"

	self assert: (aColoredPoint binarySend: #getIV with: #x) = 24.
	aColoredPoint send: #setIV withArguments: #(#x 25).
	self assert: (aColoredPoint binarySend: #getIV with: #x) = 25.

	self assert: (aColoredPoint binarySend: #getIV with: #color) = #blue.	

	"adding some methods"

	coloredPointClass 
		addUnaryMethod: #giveColor
		withBody: 'objself binarySend: #getIV with: #color'.

	coloredPointClass 
		addMethod: #setColor
		args: 'col'
		withBody:' objself send: #setIV withArguments: (Array with: #color with: col)'.

	coloredPointClass addUnaryMethod: #display
		withBody:  
			'objself'.
			
			
	self assert: (aColoredPoint unarySend: #giveColor) = #blue.
	
	self assert: (aColoredPoint unarySend: #givex) = 25.
	
	aColoredPoint unarySend: #display! !

TestCase subclass: #ObjTest
	instanceVariableNames: 'objectClass aPoint coloredPointClass pointClass classClass aColoredPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-ObjVLisp'!

!ObjTest methodsFor: 'setup' stamp: ''!
assembleClassClass
	classClass := Obj new: 6.
	classClass at: classClass offsetForName put: #ObjClass.
	classClass at: classClass offsetForClass put: #ObjClass.
	classClass at: classClass offsetForIVs
		put: #(#class #name #superclass #iv #keywords #methodDict).
	classClass at: classClass offsetForKeywords
		put: #(#name: #superclass: #iv: #keywords: #methodDict:).
	classClass at: classClass offsetForSuperclass put: #ObjObject.
	classClass at: classClass offsetForMethodDict
		put: (IdentityDictionary new).
	Obj declareClass: classClass! !

!ObjTest methodsFor: 'setup' stamp: ''!
assembleColoredInstance
	aColoredPoint := Obj new: 4.
	aColoredPoint at: 1 put: #ObjColoredPoint.
	aColoredPoint at: 2 put: 10.
	aColoredPoint at: 3 put: 15.
	aColoredPoint at: 3 put: #blue! !

!ObjTest methodsFor: 'setup' stamp: ''!
assembleColoredPointClass
	coloredPointClass := Obj new: 6.
	coloredPointClass at: pointClass offsetForName put: #ObjColoredPoint.
	coloredPointClass at: pointClass offsetForClass put: #ObjClass.
	coloredPointClass at: pointClass offsetForIVs put: #(#color).
	coloredPointClass at: pointClass offsetForSuperclass put: #ObjPoint.
	coloredPointClass at: pointClass offsetForMethodDict
		put: (IdentityDictionary new).
	Obj declareClass: coloredPointClass.

	(coloredPointClass at: coloredPointClass offsetForMethodDict) at: #print
		put: 
			([ :superClassOfClassDefiningTheMethod | 
				[:objself | 
				Transcript show: 'I''am a colored point';
				cr]] value: pointClass).

	(coloredPointClass at: coloredPointClass offsetForMethodDict) at: #foo
		put: 
			([ :superClassOfClassDefiningTheMethod | 
				[:objself | 
				(objself unarySuper: #foo from: superClassOfClassDefiningTheMethod) + (objself unarySuper: #foo from: superClassOfClassDefiningTheMethod)
				]] value: pointClass).

	(coloredPointClass at: coloredPointClass offsetForMethodDict) at: #bar
		put: 
			([ :superClassOfClassDefiningTheMethod | 
				[:objself | 
				(objself unarySuper: #bar from: superClassOfClassDefiningTheMethod) + (objself unarySuper: #bar from: superClassOfClassDefiningTheMethod)]
			] value: pointClass).! !

!ObjTest methodsFor: 'setup' stamp: 'stephane.ducasse 10/13/2008 15:29'!
assembleObjectClass
	objectClass := Obj new: 6.
	objectClass at: objectClass offsetForName put: #ObjObject.
	objectClass at: objectClass offsetForClass put: #ObjClass.
	objectClass at: objectClass offsetForIVs put: #(#class).
	objectClass at: objectClass offsetForKeywords put: #().
	objectClass at: objectClass offsetForSuperclass put: nil.
	objectClass at: objectClass offsetForMethodDict put: (IdentityDictionary new).
	Obj declareClass: objectClass.

	"here I simulate by hand the way superclass is captured for super lookup, I value the block with nil for now to represent
	the superclass of ObjObject"

	(objectClass at: objectClass offsetForMethodDict) at: #print
		put: 
			([:superClassOfClassDefiningTheMethod |
				[:objself | 
			Transcript show: 'I''am an Object';
				cr]] value: nil).

	(objectClass at: objectClass offsetForMethodDict) at: #error
		put: 
			([:superClassOfClassDefiningTheMethod |
				[:object :selector | 
			Transcript show: 'Error: selector ' , selector printString , 'not understood';
				cr.
				object error]] value: nil).

	(objectClass at: objectClass offsetForMethodDict) at: #getIV
		put: ([:superClassOfClassDefiningTheMethod | [:object :iv | object valueOfInstanceVariable: iv]] value: nil).

	(objectClass at: objectClass offsetForMethodDict) at: #setIV
		put: 
			([:superClassOfClassDefiningTheMethod | [:object :iv :val | 
			object at: (object offsetFromObjectOfInstanceVariable: iv) put: val]] value: nil).

	(objectClass at: objectClass offsetForMethodDict) at: #bar
		put: 
			([:superClassOfClassDefiningTheMethod | [:objself | 
					5]] value: nil).! !

!ObjTest methodsFor: 'setup' stamp: ''!
assemblePointClass
	| cl |
	cl := Obj giveClassNamed: #ObjClass.
	pointClass := Obj new: (cl at: cl offsetForIVs) size.
	pointClass at: pointClass offsetForName put: #ObjPoint.
	pointClass at: pointClass offsetForClass put: #ObjClass.
	pointClass at: pointClass offsetForIVs put: #(#class #x #y).
	pointClass at: pointClass offsetForKeywords put: #(#x: #y:).
	pointClass at: pointClass offsetForSuperclass put: #ObjObject.
	pointClass at: pointClass offsetForMethodDict
		put: (IdentityDictionary new).
	Obj declareClass: pointClass.

	(pointClass at: pointClass offsetForMethodDict) at: #x
		put: ([ :superClassOfClassDefiningTheMethod | [:objself | objself valueOfInstanceVariable: #x]] value: objectClass).

	(pointClass at: pointClass offsetForMethodDict) at: #print
		put: 
			([ :superClassOfClassDefiningTheMethod | [:objself | 
			Transcript show: 'I''am a Point';
				cr]] value: objectClass).

	(pointClass at: pointClass offsetForMethodDict) at: #foo
		put: 
			([ :superClassOfClassDefiningTheMethod | 
				[:objself | 
				Transcript show: 'ObjPoint>>foo';cr.
				5
				]] value: objectClass)! !

!ObjTest methodsFor: 'setup' stamp: ''!
assemblePointInstance
	aPoint := Obj new: 3.
	aPoint at: 1 put: #ObjPoint.
	aPoint at: 2 put: 10.
	aPoint at: 3 put: 15! !

!ObjTest methodsFor: 'setup' stamp: ''!
setUp
	"self new setUp"

	Obj initialize.
	self assembleClassClass.
	self assemblePointClass.
	self assembleObjectClass.
	self assembleColoredPointClass.
	self assemblePointInstance.
	self assembleColoredInstance.! !

!ObjTest methodsFor: 'tests' stamp: 'stephane.ducasse 9/29/2008 13:56'!
testAllocate
	"(self  selector: #testAllocate) run"

	| newInstance testInstance |
	testInstance := Obj new: 3.
	testInstance at: 1 put: #ObjPoint.
	newInstance := pointClass allocateAnInstance.
	self assert: (newInstance = testInstance).
	self assert: (newInstance objClass = pointClass)! !

!ObjTest methodsFor: 'utilities tests' stamp: ''!
testBlockArgsFrom

	self assert: (Obj new blockArgsFrom: ' abc def ghi ')  = ':abc :def :ghi'.
	self assert: (Obj new blockArgsFrom: 'abc def ghi')  = ':abc :def :ghi'.
	self assert: (Obj new blockArgsFrom: '')  = ''.! !

!ObjTest methodsFor: 'utilities tests' stamp: 'stephane.ducasse 9/29/2008 14:52'!
testBlockBodyFromHeaderAndBody

	"a method with one argument: val"
	self assert: (Obj new stringOfBlockBodyFromHeader: 'val' andBody: 'objself send: #setIV 
										 withArguments: (Array with: #x with: val).')
										= '[ :superClassOfClassDefiningTheMethod |
		[ :objself :val |
					 objself send: #setIV 
										 withArguments: (Array with: #x with: val).] fixTemps]'.

	"a method without arg"
	self assert: (Obj new stringOfBlockBodyFromHeader: '' andBody: 'objself unarySend: #getx.') 
	='[ :superClassOfClassDefiningTheMethod |
		[ :objself  |
					 objself unarySend: #getx.] fixTemps]'
	! !

!ObjTest methodsFor: 'tests' stamp: ''!
testClassAccess
	"(self  selector: #testClassAccess) run"
	
	self assert: (aPoint objClass = pointClass)! !

!ObjTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 7/11/2010 03:00'!
testErrorRedefinition
	"(self  run: #testErrorRedefinition)"
	
	self should: [aPoint unarySend: #zork] raise: Error.

	(pointClass at: pointClass offsetForMethodDict) at: #error
		put: ([ :superClassOfClassDefiningTheMethod | [:objself :patate  | [:toto|33]]] value: objectClass).

	self assert: (aPoint unarySend: #zork) = 33.
	
	"this is not enough since we redefined error as a unary method here but it is a binary and it should work for all of them.
	In fact we have to reify the message and discard the computation"

	(pointClass at: pointClass offsetForMethodDict) at: #error
		put: ([ :superClassOfClassDefiningTheMethod | [:objself :patate  | [:toto :titi |33]]] value: objectClass).

	self assert: (aPoint binarySend: #zork with: 44) = 33.! !

!ObjTest methodsFor: 'tests' stamp: ''!
testIVOffset
	"(self  selector: #testIVOffset) run"

	self assert: ((pointClass offsetFromClassOfInstanceVariable: #x ) = 2).
	self assert: ((pointClass offsetFromClassOfInstanceVariable: #lulu ) = 0)! !

!ObjTest methodsFor: 'tests' stamp: ''!
testIVOffsetAndValue
	"(self  selector: #testIVOffsetAndValue) run"

	self assert: ((aPoint offsetFromObjectOfInstanceVariable: #x ) = 2).
	self assert: ((aPoint valueOfInstanceVariable: #x ) = 10)! !

!ObjTest methodsFor: 'tests' stamp: ''!
testInitialize
	"(self  selector: #testInitialize) run"

	| newInstance testInstance |
	newInstance := pointClass allocateAnInstance.
	testInstance := Obj new: 3.
	testInstance at: 1 put: #ObjPoint.
	testInstance at: 2 put: 1.
	testInstance at: 3 put: 2.
	newInstance initializeUsing: #(#y: 2 #z: 3 #t: 55 #x: 1).
	self assert: (newInstance = testInstance)! !

!ObjTest methodsFor: 'tests' stamp: ''!
testInstanceVariableInheritance
	"(self  selector: #testInstanceVariableInheritance) run"

	"a better choice would be to throw an exception if there are duplicates"
	self assert: 
			((Obj new computeNewIVFrom: #(#a #b #c #d) asOrderedCollection
				with: #(#a #z #b #t) asOrderedCollection)
					= #(#a #b #c #d #z #t) asOrderedCollection).
	self assert: 
			((Obj new computeNewIVFrom: #() asOrderedCollection
				with: #(#a #z #b #t) asOrderedCollection)
					= #(#a #z #b #t) asOrderedCollection)! !

!ObjTest methodsFor: 'tests' stamp: ''!
testKeywords
	"(self  selector: #testKeywords) run"

	| dummyObject |
	dummyObject := Obj new.
	self assert: 
			((dummyObject generateKeywords: #(#titi #toto #lulu))
				= #(#titi: #toto: #lulu:)).
	self assert: 
			((dummyObject keywordValue: #x
				getFrom: #(#toto 33 #x 23)
				ifAbsent: 2) = 23).
	self assert: 
			((dummyObject keywordValue: #x
				getFrom: #(#toto 23)
				ifAbsent: 2) = 2).
	self assert: 
			((dummyObject returnValuesFrom: #(#x 22 #y 35) followingSchema: #(#y #yy #x #y))
				= #(35 nil 22 35))! !

!ObjTest methodsFor: 'tests' stamp: ''!
testMethodDefinition
	"(self  selector: #testMethodManagment) run"

	self assert: (pointClass doesUnderstand: #x).
	self assert: (pointClass doesUnderstand: #xx) not.

	"define a unary method xx returning the receiver."
	pointClass 
		addMethod: #xx
		args: ''
		withBody: 'objself'.

	self assert: (pointClass doesUnderstand: #xx).
	self assert: (((pointClass bodyOfMethod: #xx) value: 22) = 22).

	"define a unary method returning the slot x of the receiver"
	pointClass 
		addMethod: #getgetx
		args: ''
		withBody: 'objself valueOfInstanceVariable: #x'.
	self assert: (pointClass doesUnderstand: #getgetx).
	self assert: (((pointClass bodyOfMethod: #getgetx) value: aPoint) = 10).! !

!ObjTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 7/11/2010 01:26'!
testMethodLookup
	"(self  selector: #testMethodLookup) run"
	
	self assert: ((pointClass lookup: #x for: aPoint) isKindOf: BlockClosure)! !

!ObjTest methodsFor: 'tests' stamp: ''!
testMethodManagment
	"(self  selector: #testMethodManagment) run"

	self assert: (pointClass doesUnderstand: #x).
	self assert: (pointClass doesUnderstand: #xx) not.
	
	pointClass 
		addMethod: #xx
		args: ''
		withBody: 'objself valueOfInstanceVariable: #x '.
	self assert: (((pointClass bodyOfMethod: #xx) value: aPoint) = 10).
	self assert: (pointClass doesUnderstand: #xx).
	pointClass removeMethod: #xx.
	self assert: (pointClass doesUnderstand: #xx) not.
	self assert: (((pointClass bodyOfMethod: #x) value: aPoint) = 10)! !

!ObjTest methodsFor: 'tests' stamp: ''!
testMethodNotFoundRaiseError
	"(self  run: #testMethodNotFoundRaiseError)"

	self should: [aPoint unarySend: #zork] raise: Error.! !

!ObjTest methodsFor: 'tests' stamp: ''!
testMethodSelfSend
	"(self  selector: #testMethodSelfSend) run"

	"method found in the class PointClass"
	self assert: ((aPoint unarySend: #x) = 10).

	"method found in ObjClass"
	self assert: ((aPoint binarySend: #getIV with: #x) = 10).

	"method found in ObjClass"
	aPoint send: #setIV withArguments: #(y 22).
	self assert: ((aPoint binarySend: #getIV with: #y) = 22)! !

!ObjTest methodsFor: 'tests' stamp: ''!
testMethodSuperCall
	"(self  selector: #testMethodSuperCall) run"

	"foo in point return 5"
	self assert: ((aPoint unarySend: #foo) = 5).

	"foo in colored point is doing super foo + super foo"
	self assert: ((aColoredPoint unarySend: #foo) = 10).! !

!ObjTest methodsFor: 'tests' stamp: ''!
testMethodSuperCallOverBigHierarchy
	"(self  selector: #testMethodSuperCallOverBigHierarchy) run"

	"bar is defined in Object and not on Point"
	self assert: (aPoint unarySend: #bar) = 5.

	"bar on coloredPoint = super bar + super bar"
	self assert: (aColoredPoint unarySend: #bar) = 10.! !

!ObjTest methodsFor: 'utilities tests' stamp: ''!
testMethodWithHeaderAndBody

	"a method simply returning objself"
	self assert: ((pointClass
					methodWithHeader: ''
					andBody: 'objself ') value: 2) = 2.
	
	"a method returning its first none implicit arg"
	self assert: ((pointClass 
					methodWithHeader: 'val'
					andBody: 'val ') value: 2 value: 33) = 33.

	"a method returns its superclass of the class defining the method value"
	"this anonymous method is defined in pointClass so its superclass pointer is objectClass"
	self assert: ((pointClass 
					methodWithHeader: ''
					andBody: ' superClassOfClassDefiningTheMethod ') value: aPoint) = objectClass .

	self assert: ((coloredPointClass 
					methodWithHeader: ''
					andBody: ' superClassOfClassDefiningTheMethod ') value: aPoint) = pointClass .! !

!ObjTest methodsFor: 'tests' stamp: ''!
testPrimitiveStructure
	"(self selector: #testPrimitiveStructure) run"

	self assert: (pointClass objClassId = #ObjClass).
	self assert: ((pointClass objName ) = #ObjPoint).
	self assert: ((pointClass objSuperclassId ) = #ObjObject).
	self assert: ((pointClass objIVs) = #(#class #x #y)).
	self assert: ((pointClass objKeywords) = #(#x: #y:)).
	self assert: ((pointClass objMethodDict) = nil) not! !

TestCase subclass: #ObjTestBootstrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-ObjVLisp'!

!ObjTestBootstrap methodsFor: 'test ObjClass creation' stamp: ''!
testCreateObjClassMessage
	"(self selector: #testCreateObjClassMessage) run"

	| objClass |
	Obj bootstrap.
	objClass := Obj giveClassNamed: #ObjClass.
	self
		should: [(objClass unarySend: #class) = (Obj giveClassNamed: #ObjClass)].
	self should: [objClass unarySend: #isClass].
	self should: [objClass unarySend: #isMetaclass]! !

!ObjTestBootstrap methodsFor: 'test ObjClass creation' stamp: ''!
testCreateObjClassStructure
	"(self selector: #testCreateObjClassStructure) run"

	| objClass |
	Obj bootstrap.
	objClass := Obj giveClassNamed: #ObjClass.
	self should: [objClass objName = #ObjClass].
	self should: [objClass objClassId = #ObjClass].
	self should: [objClass objSuperclassId = #ObjObject].
	self should: 
			[objClass objIVs asArray
				= #(#class #name #superclass #iv #keywords #methodDict)].
	self should: 
			[objClass objKeywords asArray
				= #(#name: #superclass: #iv: #keywords: #methodDict:)]! !

!ObjTestBootstrap methodsFor: 'test ObjObject creation ' stamp: ''!
testCreateObjObjectInstanceMessage
	"(self selector: #testCreateObjObjectInstanceMessage) run"

	| pointClass objClass pointInstance |
	Obj initialize.
	Obj manuallyCreateObjClass.
	Obj createObjObject.
	objClass := Obj giveClassNamed: #ObjClass.
	pointClass := objClass send: #new
				withArguments: #(#(#name: #ObjPoint 
								  #superclass: #ObjObject #iv: #(#x #y))).
	pointInstance := pointClass send: #new withArguments: #(#()).
	self should: [pointInstance objClassId = #ObjPoint].
	self should: [(pointInstance binarySend: #getIV with: #x) = nil].
	self should: 
			[pointInstance send: #setIV withArguments: #(#x 25).
			(pointInstance binarySend: #getIV with: #x) = 25]! !

!ObjTestBootstrap methodsFor: 'test ObjObject creation ' stamp: ''!
testCreateObjObjectMessage
	"(self selector: #testCreateObjObjectMessage) run"

	| objObject |
	Obj initialize.
	Obj manuallyCreateObjClass.
	Obj createObjObject.
	objObject := Obj giveClassNamed: #ObjObject.
	self
		should: [(objObject unarySend: #class) = (Obj giveClassNamed: #ObjClass)].
	self should: [(objObject unarySend: #isClass) not].
	self should: [(objObject binarySend: #getIV with: #class) = #ObjClass]! !

!ObjTestBootstrap methodsFor: 'test ObjObject creation ' stamp: 'stephane.ducasse 9/29/2008 14:32'!
testCreateObjObjectStructure
	"(self selector: #testCreateObjObjectStructure) run"

	| objObject |
	Obj initialize.
	Obj manuallyCreateObjClass.
	Obj createObjObject.
	objObject := Obj giveClassNamed: #ObjObject.
	self assert: (objObject objName = #ObjObject).
	self assert: (objObject objClassId = #ObjClass).
	self assert: (objObject objSuperclassId isNil).
	self assert: (objObject objIVs asArray = #(#class)).
	self assert: (objObject objKeywords asArray = #())! !

!ObjTestBootstrap methodsFor: 'test ObjClass manual creation ' stamp: ''!
testManuallyCreateObjClassAllocate
	"(self selector: #testManuallyCreateObjClassAllocate) run"

	| objClass emptyClass |
	Obj initialize.
	Obj manuallyCreateObjClass.
	objClass := Obj giveClassNamed: #ObjClass.
	emptyClass := objClass unarySend: #allocate.
	self assert: emptyClass objClassId = #ObjClass.
	self assert:  emptyClass objSuperclassId isNil.
	self assert:  emptyClass objIVs isNil.
	self assert:  emptyClass objKeywords isNil.
	self assert:  emptyClass objMethodDict isNil.
	self assert:  emptyClass objName isNil! !

!ObjTestBootstrap methodsFor: 'test ObjClass manual creation ' stamp: ''!
testManuallyCreateObjClassStructure
	"(self selector: #testManuallyCreateObjClassStructure) run"

	| objClass |
	Obj initialize.
	Obj manuallyCreateObjClass.
	objClass := Obj giveClassNamed: #ObjClass.
	self assert: (objClass objName = #ObjClass).
	self assert: (objClass objClassId = #ObjClass).
	self assert: (objClass objClass == objClass).
	self assert: (objClass objSuperclassId = #ObjObject).	
	"the fact that the created first class inherits form ObjObject is not necessary
	because there is no super calls"
	self assert: 
			(objClass objIVs = #(#class #name #superclass #iv #keywords #methodDict)).
	self assert: 
			(objClass objKeywords = #(#name: #superclass: #iv: #keywords: #methodDict:))! !

PolygonMorph subclass: #Liaison
	instanceVariableNames: 'source destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-BublingMorpg'!

!Liaison methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 6/18/2010 20:38'!
delete
	
	super delete.
	self source isNil
	ifFalse:[self source linesCollection remove: self].
	
	self destination isNil
	ifFalse:[self destination linesCollection remove: self].! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:00'!
destination
	^ destination! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:01'!
destination: aMyRoundedMorph
	destination := aMyRoundedMorph.
	aMyRoundedMorph addLine: self.! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/8/2010 18:22'!
draw
	super delete.
	self vertices: {self source center. self destination center}
			color: Color black borderWidth: 2 borderColor: (Color black).
	self openInWorld.
	self passivate.! !

!Liaison methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/15/2010 13:12'!
initialize

	super initialize.
	self beSticky.! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:00'!
source
	^ source! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:29'!
source: aMyRoundedMorph
	source := aMyRoundedMorph.
	aMyRoundedMorph addLine: self.! !

!Liaison methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/17/2010 03:17'!
step

	self source isNil | self destination isNil
	ifFalse: [self draw].! !

!Liaison methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/17/2010 02:55'!
stepTime
	^ 250.! !

BorderedMorph subclass: #MyRoundedMorph
	instanceVariableNames: 'stringMorph linesCollection refresh margeX margeY'
	classVariableNames: 'CanMakeAChild'
	poolDictionaries: ''
	category: 'Summer2010-BublingMorpg'!

!MyRoundedMorph commentStamp: '<historical>' prior: 0!
(MyRoundedMorph new with: 'Foo' where: 220 @ 300 color: Color blue) openInWorld!

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/8/2010 18:12'!
addLine: aLiaison.

	self linesCollection add: aLiaison.
	aLiaison visible 
		ifFalse:[aLiaison openInWorld].
	self addMorphBack: aLiaison! !

!MyRoundedMorph methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 6/20/2010 01:40'!
canIPutAChildHere: aRectangle
	|list|
	
	list := OrderedCollection new.
	self class allInstances do:[:each |
		((each bounds containsPoint: aRectangle topLeft) 		|
		(each bounds containsPoint: aRectangle topRight) 		|
		(each bounds containsPoint: aRectangle bottomLeft)	|
		(each bounds containsPoint: aRectangle bottomRight)) &
		((each = self) not)
		ifTrue:[list add: each]].

^list isEmpty.



! !

!MyRoundedMorph methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 6/18/2010 20:28'!
delete
	
	self deleteLines.
	self stringMorph isNil
		ifFalse:[	self stringMorph delete ].
	super delete.! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 20:33'!
deleteLines
	|tempList|
	
	tempList := OrderedCollection new.
	self linesCollection collect:[:each| tempList add: each ].
			
	tempList do:[:each|
		each source = self
		ifTrue: [each destination delete]
		ifFalse: [each delete]]! !

!MyRoundedMorph methodsFor: 'events-processing' stamp: 'sd 7/9/2010 13:35'!
handleEvent: anEvent
	"Handle the given event"
	
	anEvent isMouse
		ifTrue:[
			anEvent isDraggingEvent
			ifTrue:[self linesStartStepping]
			ifFalse:[self linesStopStepping].
			anEvent blueButtonPressed
				ifTrue: [
					CanMakeAChild
					ifTrue:[self makeAChild].
					CanMakeAChild := false]
				ifFalse:[CanMakeAChild := true]].
	^anEvent sentTo: self.! !

!MyRoundedMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/18/2010 20:21'!
initialize 

	super initialize .
	self useRoundedCorners.
	margeX := 10.
	margeY := 15.
	linesCollection := OrderedCollection new.
	CanMakeAChild := true.! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:40'!
linesCollection
	^ linesCollection! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:40'!
linesCollection: anObject
	linesCollection := anObject! !

!MyRoundedMorph methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 6/17/2010 03:02'!
linesStartStepping

	self linesCollection do:[:each| each startStepping].! !

!MyRoundedMorph methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 6/17/2010 03:02'!
linesStopStepping

	self linesCollection do:[:each| each stopStepping].! !

!MyRoundedMorph methodsFor: 'submorphs-add/remove' stamp: 'BenjaminVanRyseghem 7/8/2010 18:24'!
makeAChild
	|child childLabel childPoint childColor|
	
	childLabel := self stringMorph text, '''s child'.
	childPoint := ((self bottomRight x) + 75)@((self bottomRight y) + 75).
	childColor := self color lighter lighter lighter lighter .
	
	child := self class new with: childLabel where: childPoint color: childColor.
	child openInWorld.
	
	Liaison new source: self; destination: child; draw; openInWorld.! !

!MyRoundedMorph methodsFor: 'initialization' stamp: 'sd 7/9/2010 13:35'!
openInWorld 

	super openInWorld.
	self stringMorph isNil
		ifFalse:[	
			self stringMorph openInWorld .
			self addMorphFront: (self stringMorph)].
	^ self.! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 05:32'!
resize
	| width height aPoint |
		
	aPoint := self topLeft.
	
	self stringMorph topLeft: ((aPoint x+margeX)@(aPoint y+margeY)).
	
	width := self stringMorph width + (2 * margeX).
	height := self stringMorph height + (2 * margeY).
	
	self 	bounds: (aPoint corner: ((aPoint x+width)@(aPoint y+height))).! !

!MyRoundedMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/20/2010 01:45'!
setPosition: point width: width height: height
	| block |
	block := [ 
		self stringMorph topLeft: (point x + margeX) @ (point y + margeY).
		self bounds: (point corner: (point x + width) @ (point y + height))].
	
	block value.
	
	[ self canIPutAChildHere: self bounds ]
		whileFalse: [ 
			point setX: point x + width setY: point y.
			block value ]! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:05'!
stringMorph
	^ stringMorph! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:05'!
stringMorph: anObject
	stringMorph := anObject! !

!MyRoundedMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/20/2010 01:44'!
with: aString where: aPoint color: aColor
	| width height point |
	self
		topLeft: aPoint;
		color: aColor.
	point := aPoint.
	self stringMorph: (MyTextFieldMorph new with: aString container: self).
	width := self stringMorph width + (2 * margeX).
	height := self stringMorph height + (2 * margeY).
	self setPosition: point width: width height: height.! !

TextMorphForFieldView subclass: #MyOtherTextMorphForFieldView
	instanceVariableNames: 'sender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-JumpingJack'!

!MyOtherTextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/8/2010 18:03'!
handleKeyDown: anEvent
	"System level event handling."
	
	self sender container keyPressed: (anEvent keyString).
			
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:[^self].
	anEvent wasHandled: true.
	^self keyDown: anEvent! !

!MyOtherTextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/8/2010 18:04'!
handleKeyUp: anEvent
	"System level event handling."
		
	self sender container keyReleased: (anEvent keyString).
		
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:[^self].
	anEvent wasHandled: true.
	^self keyUp: anEvent! !

!MyOtherTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
sender
	^ sender! !

!MyOtherTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:22'!
sender: anObject
	sender := anObject! !

!MyOtherTextMorphForFieldView methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 22:23'!
with: aClass

	self sender: aClass.! !

TextMorphForFieldView subclass: #MyTextMorphForFieldView
	instanceVariableNames: 'sender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-BublingMorpg'!

!MyTextMorphForFieldView methodsFor: 'events-processing' stamp: 'BenjaminVanRyseghem 6/18/2010 15:03'!
handleKeystroke: anEvent
	"System level event handling."

	| pasteUp |
	self sender resize.
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:	[^ self].
	anEvent wasHandled: true.
	anEvent keyCharacter = Character tab ifTrue:
		["Allow passing through text morph inside pasteups"
		(self wouldAcceptKeyboardFocusUponTab and:
				[(pasteUp := self pasteUpMorphHandlingTabAmongFields) notNil])
			ifTrue:[^ pasteUp tabHitWithEvent: anEvent]].
	self keyStroke: anEvent! !

!MyTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 05:18'!
sender
	^ sender! !

!MyTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 05:18'!
sender: anObject
	sender := anObject! !

!MyTextMorphForFieldView methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2010 05:18'!
with: aClass

	self sender: aClass.! !

Array variableSubclass: #Obj
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-ObjVLisp'!

Obj class
	instanceVariableNames: 'definedObjClasses'!

Obj class
	instanceVariableNames: 'definedObjClasses'!

!Obj classSide methodsFor: 'bootstrap objClass manually' stamp: ''!
bootstrap
	"self bootstrap"
	
	self initialize.
	self manuallyCreateObjClass.
	self createObjObject.
	self createObjClass.! !

!Obj classSide methodsFor: 'ObjAbstract' stamp: 'BenjaminVanRyseghem 7/11/2010 01:40'!
createObjAbstract

	| objAbstractClass |
	objAbstractClass := self objAbstractStructure.
	
	objAbstractClass
		addMethod:  #new
		args:  'anArray'
		withBody:  'objself error: objself objClassId, '' is an abstract class'''.

	^objAbstractClass! !

!Obj classSide methodsFor: 'bootstrap objClass' stamp: ''!
createObjClass
	"self bootstrap"

	| objClass |
	objClass := self objClassStructure.
	self defineAllocateMethodIn: objClass.
	self defineNewMethodIn: objClass.
	self defineInitializeMethodIn: objClass.
	objClass 
		addUnaryMethod: #isMetaclass
		withBody: 'objself objIVs includes: #superclass'.	
	"an object is a class if is class is a metaclass. cool"
	
	objClass 
		addUnaryMethod: #isClass
		withBody: 'objself objClass unarySend: #isMetaclass'.

	^objClass! !

!Obj classSide methodsFor: 'ObjColoredPoint' stamp: 'BenjaminVanRyseghem 7/11/2010 02:02'!
createObjColoredPoint

	| objPoint |
	objPoint := self objColoredPointStructure.
	objPoint addUnaryMethod: #color withBody: 'objself valueOfInstanceVariable: #color'.

	^objPoint! !

!Obj classSide methodsFor: 'ObjGettersSetters' stamp: 'BenjaminVanRyseghem 7/11/2010 02:12'!
createObjGettersSetters
	| objGS |
	
	objGS := self objGettersSettersStructure.
	
	objGS 
		addMethod:  #initialize
		args: 'initArgs'
		withBody: '
			objself binarySuper:#initialize with: initArgs from: superClassOfClassDefiningTheMethod.
			objself objIVs do:[:each|
				objself
					addMethod: (each, '':'') asSymbol
					args: ''anObject''
					withBody: each, '' := anObject''.
				objself
					addMethod: each asSymbol
					args: ''''
					withBody:each,''''.].
				objself' .
	^objGS ! !

!Obj classSide methodsFor: 'bootstrap objObject' stamp: 'BenjaminVanRyseghem 7/11/2010 02:29'!
createObjObject
	| objObject |
	objObject := self objObjectStructure.
	objObject addUnaryMethod: #class withBody: 'objself objClass'.
	objObject addUnaryMethod: #isClass withBody: 'false'.
	objObject addUnaryMethod: #isMetaclass withBody: 'false'. 
	objObject 
		addMethod: #error
		args: 'aString'
		withBody: 'objself error: aString'.

	"some meta facilities"
	objObject 
		addMethod: #getIV
		args: 'iv'
		withBody: 'objself valueOfInstanceVariable: iv'.

	objObject 
		addMethod: #setIV
		args: 'iv val'
		withBody: 
			' objself at: (objself offsetFromObjectOfInstanceVariable: iv) put: val'.

	objObject 
		addMethod: #initialize
		args: 'initargs'
		withBody: 'objself  initializeUsing: initargs'.
			
	^objObject! !

!Obj classSide methodsFor: 'ObjPoint' stamp: 'BenjaminVanRyseghem 7/11/2010 02:09'!
createObjPoint

	| objPoint |
	objPoint := self objPointStructure.
	objPoint addUnaryMethod: #givex withBody: 'objself valueOfInstanceVariable: #x'.
	objPoint addUnaryMethod: #givey withBody: 'objself valueOfInstanceVariable: #y'.
	
	objPoint 
		addMethod:  #setx:
		args: 'aNumber'
		withBody: 'objself objIVs at: (objself offsetFromObjectOfInstanceVariable: #x) put: aNumber'.
	
		objPoint 
		addMethod:  #sety:
		args: 'aNumber'
		withBody: 'objself objIVs at: (objself offsetFromObjectOfInstanceVariable: #y) put: aNumber'.

	^objPoint! !

!Obj classSide methodsFor: 'global class repository management' stamp: ''!
declareClass: anObjClass 
	"To declare an ObjClass in the class repository"

	| nameC |
	nameC := anObjClass objName.
	nameC isNil
		ifFalse: [definedObjClasses at: nameC put: anObjClass]
		ifTrue: [self error: 'The class does not have a name']! !

!Obj classSide methodsFor: 'bootstrap objClass manually' stamp: ''!
defineAllocateMethodIn: class 

	class 
		addUnaryMethod: #allocate 
		withBody: 'objself allocateAnInstance'! !

!Obj classSide methodsFor: 'bootstrap objClass' stamp: 'BenjaminVanRyseghem 7/10/2010 18:42'!
defineInitializeMethodIn: objClass 

	objClass 
		addMethod: #initialize
		args: 'initArray'
		withBody: 
			'objself binarySuper: #initialize with: initArray from: superClassOfClassDefiningTheMethod.
			objself objIVs: (objself
							computeNewIVFrom: (Obj giveClassNamed: objself objSuperclassId) objIVs
							with: objself objIVs).
			objself computeAndSetKeywords.
			objself objMethodDict: IdentityDictionary new.
			Obj declareClass: objself.
			objself'! !

!Obj classSide methodsFor: 'bootstrap objClass manually' stamp: ''!
defineManualInitializeMethodIn: class 

	class 
		addMethod: #initialize
		args: 'initArray'
		withBody: 	
			'| objsuperclass |
			objself initializeUsing: initArray.	"Initialize a class as an object. In the bootstrapped system will be done via super"
			objsuperclass := Obj giveClassNamed: objself objSuperclassId ifAbsent: [nil].
			objsuperclass isNil
				ifFalse: 
					[objself
						objIVs: (objself computeNewIVFrom: objsuperclass objIVs with: objself objIVs)]
				ifTrue: 
					[objself objIVs: (objself computeNewIVFrom: #(#class) with: objself objIVs)].
			objself
				objKeywords: (objself generateKeywords: (objself objIVs copyWithout: #class)).
			objself objMethodDict: (IdentityDictionary new: 3).
			Obj declareClass: objself.
			objself'! !

!Obj classSide methodsFor: 'bootstrap objClass manually' stamp: ''!
defineNewMethodIn: class 

	class 
		addMethod: #new
		args: 'initArray'
		withBody: 
			'(objself unarySend: #allocate) binarySend: #initialize with: initArray'.! !

!Obj classSide methodsFor: 'tricks' stamp: 'stephane.ducasse 9/29/2008 14:25'!
doesNotUnderstand: aMessage

	"debugging >>>  default shiftDown ifTrue:[ self halt ]."
	"Sensor shiftPressed ifTrue:[ self halt ]."
	
	^ definedObjClasses at: aMessage selector! !

!Obj classSide methodsFor: 'global class repository management' stamp: ''!
giveClassNamed: aSymbol 
	"Return the class defined in the class repository with the name aSymbol"

	^ self giveClassNamed: aSymbol ifAbsent: [self error: ('The class ' , aSymbol printString , ' is not defined')]! !

!Obj classSide methodsFor: 'global class repository management' stamp: ''!
giveClassNamed: aSymbol ifAbsent: aBlock

	^ definedObjClasses at: aSymbol ifAbsent: aBlock! !

!Obj classSide methodsFor: 'initialize' stamp: ''!
initialize
	"self initialize"	
 
	definedObjClasses := IdentityDictionary new.
	definedObjClasses at: #ObjClass put: nil.
	definedObjClasses at: #ObjObject put: nil.! !

!Obj classSide methodsFor: 'bootstrap objClass manually' stamp: ''!
manualObjClassStructure
	| class |
	class := Obj new: 6.
	class objClassId: #ObjClass.
	class objName: #ObjClass.
	class objIVs: #(#class #name #superclass #iv #keywords #methodDict).
	class objKeywords: #(#name: #superclass: #iv: #keywords: #methodDict:).
	class objSuperclassId: #ObjObject.
	class objMethodDict: (IdentityDictionary new: 3).
	^class! !

!Obj classSide methodsFor: 'bootstrap objClass manually' stamp: ''!
manuallyCreateObjClass
	"self manuallyCreateObjClass"

	| class |
	class := self manualObjClassStructure.
	Obj declareClass: class.
	self defineManualInitializeMethodIn: class.
	self defineNewMethodIn: class.
	self defineAllocateMethodIn: class.
	^class! !

!Obj classSide methodsFor: 'ObjAbstract' stamp: 'BenjaminVanRyseghem 7/10/2010 03:33'!
objAbstractStructure
		^(Obj giveClassNamed: #ObjClass) send: #new
		withArguments: #(#(#name: #ObjAbstractClass #iv: #() #superclass: #ObjClass))! !

!Obj classSide methodsFor: 'bootstrap objClass' stamp: ''!
objClassStructure
	^(Obj giveClassNamed: #ObjClass) send: #new
		withArguments: #(#(#name: #ObjClass #iv: #(#name #superclass #iv #keywords #methodDict) #superclass: #ObjObject))! !

!Obj classSide methodsFor: 'ObjColoredPoint' stamp: 'BenjaminVanRyseghem 7/10/2010 02:58'!
objColoredPointStructure
	^(Obj giveClassNamed: #ObjClass) send: #new
		withArguments: #(#(#name: #ObjColoredPoint #iv: #(#color) #superclass: #ObjPoint))! !

!Obj classSide methodsFor: 'ObjGettersSetters' stamp: 'BenjaminVanRyseghem 7/10/2010 19:12'!
objGettersSettersStructure
		^(Obj giveClassNamed: #ObjClass) send: #new
		withArguments: #(#(#name: #ObjGettersSettersClass #iv: #() #superclass: #ObjClass))! !

!Obj classSide methodsFor: 'bootstrap objObject' stamp: ''!
objObjectStructure
	^(Obj giveClassNamed: #ObjClass) 
		send: #new
		withArguments: #(#(#name: #ObjObject #iv: #(#class)))! !

!Obj classSide methodsFor: 'ObjPoint' stamp: 'BenjaminVanRyseghem 7/10/2010 01:48'!
objPointStructure
	^(Obj giveClassNamed: #ObjClass) send: #new
		withArguments: #(#(#name: #ObjPoint #iv: #(#x #y) #superclass: #ObjObject))! !

!Obj methodsFor: 'method management' stamp: ''!
addMethod: aSelector args: aString withBody: aStringBlock 
	"Define a method with selector <aSelector> , having a string representing the arguments (ie 'aNumber aStream') 
	and a string representing the method body in the receiver.
	If a method with the same selector already existed, the new definition will erase it.
	self is an objClass"

	self  objMethodDict at: aSelector put: (self methodWithHeader: aString andBody: aStringBlock).
	^self! !

!Obj methodsFor: 'method management' stamp: ''!
addUnaryMethod: aSelector withBody: aStringBlock 
	"Define a unary method with selector <aSelector> and a body <aaStringBlock> in the receiver.
	If a method with the same selector already existed, the new definition will erase it.
	self is an objClass"

	self  addMethod: aSelector args: '' withBody: aStringBlock! !

!Obj methodsFor: 'instance allocation' stamp: 'BenjaminVanRyseghem 7/9/2010 17:58'!
allocateAnInstance
	"Returns a newly created instance of self, an ObjClass. In this implementation the identifier of the object class is the name of the class. "
	| instance |
	
	instance := (self class new: (self numberOfIVs)). "pas de +1 car le nom est une varialbe d'instance ...'"

	instance at: 1 put: (self objName).
	"(2 to: instance size) do: [:i | instance at:i put: nil]." "<--- dj mis  nil par la mthode new:"
	^ instance.! !

!Obj methodsFor: 'message passing' stamp: 'BenjaminVanRyseghem 7/9/2010 19:17'!
binarySend: selector with: argument 
	"send the message whose selector is <selector> to the receiver. The arguments of the messages
	are an  <argument>. The method is lookep up in the class of the receiver. 
	self is an objObject or a objClass."

	| ans |
	ans := (self objClass lookup: selector for: self) value: self value: argument.
	^ ans! !

!Obj methodsFor: 'message passing' stamp: 'BenjaminVanRyseghem 7/10/2010 03:44'!
binarySuper: selector with: argument from: aSuperClass
	"send the message whose selector is <selector> to the receiver. The arguments of the messages
	are an  <argument>. The method is lookep up in the class of the receiver. 
	self is an objObject or a objClass."

	^(aSuperClass lookup: selector for: self ) value: self value: argument.! !

!Obj methodsFor: 'method management' stamp: 'stephane.ducasse 9/29/2008 14:11'!
blockArgsFrom: aCol
	"self basicNew blockArgsFrom: ' abc def ghi '"	
	
	| col st |
	col := aCol findTokens: Character space.
	col := col copyWithout: ''.
	st := ''.
	col do: [ :each | st := st , ':', each ] separatedBy: [st := st, ' '].
	^ st! !

!Obj methodsFor: 'method management' stamp: 'BenjaminVanRyseghem 7/9/2010 21:12'!
bodyOfMethod: aSelector 
	"Return the method associated with the selector <aSelector> in the receiver.
	Return nil if the selector is not defined.  self is an objClass"

	(self doesUnderstand: aSelector) 
		ifTrue:[^self objMethodDict at: aSelector]
		ifFalse: [^nil].! !

!Obj methodsFor: 'keyword management' stamp: 'stephane.ducasse 10/13/2008 14:54'!
computeAndSetKeywords
	"Compute the keywords of a given class.  As the class of an object should not be changed.
	 the keywords should note contain the keyword class. self is anObjClass"

	self objKeywords: (self generateKeywords: (self objIVs copyWithout: #class))! !

!Obj methodsFor: 'iv inheritance' stamp: 'stephane.ducasse 10/13/2008 14:57'!
computeNewIVFrom: superIVOrdCol with: localIVOrdCol
	"Returns an ordered collection that is the union without duplicate of ivOfSuper and ivOrderedCollection.
	Important the order of the instance variable is conserved"

	| ivs |
	^superIVOrdCol isNil 
		ifTrue: [localIVOrdCol]
		ifFalse: 
			[ivs := superIVOrdCol asOrderedCollection copy.
			localIVOrdCol do: [:e | (ivs includes: e) ifFalse: [ivs add: e]].
			ivs]! !

!Obj methodsFor: 'iv inheritance' stamp: ''!
computeNewIVFromClass: anObjClass with: ivOrderedCollection 
	"Obj computeNewIVFromClass: #(#C #C #O #(a b c d)) with: #(a z b t) asOrderedCollection"

	| ivs |
	^anObjClass isNil
		ifTrue: [ivOrderedCollection]
		ifFalse: 
			[ivs := anObjClass objIVs asOrderedCollection copy.
			ivOrderedCollection do: [:e | (ivs includes: e) ifFalse: [ivs add: e]].
			ivs]! !

!Obj methodsFor: 'debugging' stamp: ''!
debug
	"(self giveClassNamed: #ObjClass) debug"

	"(self giveClassNamed: #ObjSet) debug"

	"ObjExtension new debug"

	"|aPt|
	aPt := ObjExtension new: 3.
	aPt at: 1 put: #ObjPoint.
	aPt debug"

	"|aPt|
	aPt := ObjExtension new: 3.
	aPt at: 1 put: #ObjPoint3.
	aPt debug"

	ObjClassInspector openOn: self! !

!Obj methodsFor: 'method management' stamp: ''!
doesUnderstand: aSelector 
	"Tell if the receiver has a method having <aSelector> as selector. self is anObjClass"

	^self objMethodDict keys includes: aSelector! !

!Obj methodsFor: 'keyword management' stamp: ''!
generateKeywords: anArray 
	"Returns an array containing the keywords made from the collection of Symbol passed as argument"
	"self new generateKeywords: #(titi toto lulu) "

	^anArray collect: [:e | (e , ':') asSymbol]! !

!Obj methodsFor: 'instance initialization' stamp: 'stephane.ducasse 9/29/2008 15:11'!
initializeUsing: anAlternatedArray 
	"Returns the receiver an ObjObject initialized according to the directives given by anAlternateArray"

	| ivValues |
	ivValues := self  returnValuesFrom: anAlternatedArray
				followingSchema: self objClass objKeywords.
	1 to:  ivValues size
			do: [:i | self at: i + 1 put: (ivValues at: i)].
	^ self ! !

!Obj methodsFor: 'keyword management' stamp: ''!
keywordValue: aSymbol getFrom: anArray ifAbsent: aDefaultValue 
	"precondition: ((length anArray) mod 2) = 0 
	returns the value associated with the keyword represented by aSymbol 
	in the initarg list represented by anArray."

	"self new keywordValue: #titi getFrom: #(toto 12 titi 23) ifAbsent: 2"
	"self new keywordValue: #titi getFrom: #(toto 23) ifAbsent: 2"

	| i |
	i := anArray indexOf: aSymbol ifAbsent: nil.
	^i isNil 
		ifTrue: [aDefaultValue] 
		ifFalse: [anArray at: i + 1]! !

!Obj methodsFor: 'method lookup' stamp: 'BenjaminVanRyseghem 7/11/2010 02:30'!
lookup: selector for: anObjObject 
	"look for the method named <selector> starting in the receiver. 
	The lookup is done for a message sent to <anObjObject>. self is an objClass"
	
	| body |
	
	body := self bodyOfMethod: selector.
	body isNil
		ifTrue: [
			(self objSuperclassId) isNil
				ifTrue: [^anObjObject binarySend: #error with: ('Unknown selector ', selector )"[:t1|t1 error: 'Unknown selector ', selector]"]
				ifFalse: [ ^(self class giveClassNamed:  (self objSuperclassId)) lookup: selector for: anObjObject]]
		ifFalse:[^body].! !

!Obj methodsFor: 'method management' stamp: 'stephane.ducasse 9/29/2008 14:38'!
methodWithHeader: col andBody: aString 

	| block string resBlock |
	string := self stringOfBlockBodyFromHeader: col andBody: aString.
	block := Compiler evaluate: string.
	block fixTemps.

	"bind superclass to the superclass of the class defining the method"
	resBlock := block value: (Obj giveClassNamed: self objSuperclassId ifAbsent: [666]).
	^resBlock! !

!Obj methodsFor: 'iv management' stamp: ''!
numberOfIVs
	"Returns the number of instance variables of the class an ObjClass"

	^self objIVs size! !

!Obj methodsFor: 'object structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:31'!
objClass
	"Returns the ObjClass object of the object and not its internal identification. Differs from classId  which is a primitive 
	to access the structure representing a class"

	^self class giveClassNamed: (self objClassId).! !

!Obj methodsFor: 'object structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:14'!
objClassId
	"Returns the identifier that identifies the class of the object. In this implementation we chose to use the class name as identifier"

	^self at: 1
	! !

!Obj methodsFor: 'object structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:14'!
objClassId: anObjClassId
	"Set the identifier that identifies the class of the object."
	
	self at:1 put: anObjClassId! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:50'!
objIVs
	
	^self at: (self offsetForIVs)! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:50'!
objIVs: anOrderedCollection 
	"Set the list of instance variable names of anObjClass"
	
	self at:(self offsetForIVs) put: anOrderedCollection.

	! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:50'!
objKeywords
	"Returns the keyword list of an ObjClass"

	^self at: (self offsetForKeywords)! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:50'!
objKeywords: anOrderedCollection
	"Sets the list of keywords of an ObjClass. Note that this method is just an accessor and does not compute the actual list of keywords"

	self at: (self offsetForKeywords) put: anOrderedCollection! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:51'!
objMethodDict
	"Returns the method dictionary of an ObjClass"

	^self at: (self offsetForMethodDict)! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:51'!
objMethodDict: aDictionary 
	"Sets the method dictionary of an ObjClass"

	self at: (self offsetForMethodDict) put: aDictionary! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:51'!
objName
	"Returns the name of an ObjClass"

	^self at: (self offsetForName)! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:51'!
objName: aName 
	"Set the name of an ObjClass"

	self at: (self offsetForName) put: aName! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:51'!
objSuperclassId
	"Returns the superclass id of anObjClass"

	^self at: (self offsetForSuperclass)! !

!Obj methodsFor: 'class structure primitive' stamp: 'BenjaminVanRyseghem 7/9/2010 17:51'!
objSuperclassId: anObjClassId
	"Set the superclass id of anObjClass"

	self at: (self offsetForSuperclass) put: anObjClassId! !

!Obj methodsFor: 'object structure offset' stamp: ''!
offsetForClass

	^1! !

!Obj methodsFor: 'class structure offset' stamp: ''!
offsetForIVs
	^4! !

!Obj methodsFor: 'class structure offset' stamp: ''!
offsetForKeywords

	^5! !

!Obj methodsFor: 'class structure offset' stamp: ''!
offsetForMethodDict

	^6! !

!Obj methodsFor: 'class structure offset' stamp: ''!
offsetForName

	^2! !

!Obj methodsFor: 'class structure offset' stamp: ''!
offsetForSuperclass

	^3! !

!Obj methodsFor: 'iv management' stamp: 'BenjaminVanRyseghem 7/9/2010 17:35'!
offsetFromClassOfInstanceVariable: aSymbol 
	"Returns the index of the instance variable named aSymbol for an class anObjClass.
	Returns 0 if the aSymbol is not present in the instance variable lists of anObjClass"

	^ self objIVs indexOf: aSymbol.! !

!Obj methodsFor: 'iv management' stamp: 'BenjaminVanRyseghem 7/9/2010 17:40'!
offsetFromObjectOfInstanceVariable: aSymbol
	"Returns the offset of the instance variable named aSymbol in the object anObjObject.
	If aSymbol is not an instance variable is not an instance variable of the object raise an error"
	| offset |
	
	offset := self objClass offsetFromClassOfInstanceVariable: aSymbol.
	
	offset = 0
		ifTrue: [^self error: 'Unknown instance variable'] 
		ifFalse: [^offset]! !

!Obj methodsFor: 'printing' stamp: ''!
printOn: aStream

	aStream nextPutAll: 'an Obj object: '.	
	super printOn: aStream! !

!Obj methodsFor: 'method management' stamp: ''!
removeMethod: aSelector
	"Remove the method with aSelector <aSymbol> in the receiver. 
	self is an objClass"

	self objMethodDict removeKey: aSelector ifAbsent: [].
	^self! !

!Obj methodsFor: 'keyword management' stamp: ''!
returnValuesFrom: anInitargArray followingSchema: anArrayOfKeywords 
	"Return the values associated with the keys. The extracted values are taken from <anInitargArray> 
	and the return values are extracted according to the schema defined by the collection of keys <anArrayOfKeywords>"

	"self new returnValuesFrom: #(lulu 22  titi 35)  followingSchema: #(titi toto lulu titi)  #(35 nil 22 35)"

	^anArrayOfKeywords collect: 
			[:e | 
			self keywordValue: e
				getFrom: anInitargArray 
				ifAbsent: nil]! !

!Obj methodsFor: 'message passing' stamp: 'BenjaminVanRyseghem 7/10/2010 04:05'!
send: selector withArguments: arguments 
	"send the message whose selector is <selector> to the receiver. The arguments of the messages
	are an array <arguments>. The method is lookep up in the class of the receiver. 
	self is an objObject or a objClass."

	| ans |

	ans := (self objClass lookup: selector for: self)
				valueWithArguments: (Array with: self) , arguments.
	^ ans! !

!Obj methodsFor: 'method management' stamp: 'stephane.ducasse 9/29/2008 14:39'!
stringOfBlockBodyFromHeader: col andBody: aString 
	^ '[ :superClassOfClassDefiningTheMethod |
		[ :objself ' , (self blockArgsFrom: col) , ' |
					 ' , aString , '] fixTemps]'! !

!Obj methodsFor: 'message passing' stamp: 'BenjaminVanRyseghem 7/10/2010 04:05'!
super: selector withArguments: arguments from: aSuperclass
	"Invoke an oveeriden method named <selector> with an array of arguments <arguments>. 
	self is an objClass. aSuperclass should be the superclass of the class containing the method using super"

	| ans |
	ans := (aSuperclass lookup: selector for: aSuperclass )
				valueWithArguments: (Array with: self) , arguments.
	^ ans! !

!Obj methodsFor: 'message passing' stamp: 'BenjaminVanRyseghem 7/11/2010 02:58'!
unarySend: selector 

	| ans |
	ans := (self objClass lookup: selector for: self) value: self.
	^ ans! !

!Obj methodsFor: 'message passing' stamp: 'BenjaminVanRyseghem 7/10/2010 04:04'!
unarySuper: selector from: anObjClass
	"anObjClass should be the superclass of the class containing the method using super"

	| ans |
	ans := (anObjClass lookup: selector for: anObjClass) value: self.
	^ ans! !

!Obj methodsFor: 'iv management' stamp: ''!
valueOfInstanceVariable: aSymbol 

	^self at: (self offsetFromObjectOfInstanceVariable: aSymbol)! !

ImageMorph subclass: #JumpingJack
	instanceVariableNames: 'string isMovingLeft isMovingRight isMovingUp isMovingDown distance jumpingIndex runningIndex isJumping currentImage currentRightImage currentLeftImage'
	classVariableNames: 'LeftImage LeftImage2 RightImage RightImage2 UpLeftImage UpRightImage'
	poolDictionaries: ''
	category: 'Summer2010-JumpingJack'!

!JumpingJack commentStamp: '<historical>' prior: 0!
JumpingJack new openInWorld !

!JumpingJack classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 7/30/2010 17:41'!
openInWorld

	^self new openInWorld! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/15/2010 02:27'!
currentImage
	^ currentImage! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/15/2010 02:29'!
currentImage: anObject
	currentImage := anObject.
	self image: anObject.! !

!JumpingJack methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 21:48'!
displayedMorphs
	|result|
	
	result := OrderedCollection new.
	World submorphs do: 
		[:each| 
				each isInWorld 
					ifTrue: [result add: each]].
										
	^result.! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:47'!
distance
	^ distance! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:47'!
distance: anObject
	distance := anObject! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 7/8/2010 18:06'!
falling: ceil

	self isJumping 
	ifFalse:[
		self bottom + (self distance) < ceil
			ifTrue: [ 
				| aPoint width height |
				self bottom: self bottom + (self distance) ]
			ifFalse: [ self bottom: ceil ]].
		
	self bottom = ceil & self isMovingDown
		ifTrue: [ self bottom: (self bottom+1)].! !

!JumpingJack methodsFor: 'events-processing' stamp: 'BenjaminVanRyseghem 7/9/2010 20:32'!
handleEvent: anEvent
	"Handle the given event"

	anEvent isMouse
		ifTrue: [ 
			anEvent isMouseOver | anEvent isDraggingEvent
				ifTrue: [
					self stopStepping.
					self keepFocus.
					owner addMorphFront: self  ]
				ifFalse: [ self startStepping ] ].
	anEvent isKeyboard
		ifTrue: [self keyPressed: anEvent keyValue ].
	^ anEvent sentTo: self! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 7/30/2010 17:35'!
incrJumpingIndex

	self incrJumpingIndex: 1.! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 6/21/2010 23:08'!
incrJumpingIndex: anInteger

	self jumpingIndex: (self jumpingIndex  + anInteger)! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 7/30/2010 17:35'!
incrRunningIndex

	self incrRunningIndex: 1.! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 7/30/2010 17:36'!
incrRunningIndex: anInteger

	self runningIndex: (self runningIndex  + anInteger)! !

!JumpingJack methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/30/2010 17:49'!
initialize 

	super initialize.
	self initializeImages.
	self currentImage: RightImage.
	self image: RightImage.
	self bounds: (100@100 corner: 150@150).
	self string: (MyOtherTextFieldMorph new with: ' ' container: self).
	self string visible: false.
		
	isMovingLeft := false.
	isMovingRight := false.
	isMovingUp := false.
	isMovingDown := false.
	isJumping := false.
	
	distance := 10.
	jumpingIndex := 0.
	runningIndex := 0.
	
	currentLeftImage:= LeftImage.
	currentRightImage := RightImage.! !

!JumpingJack methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/30/2010 17:10'!
initializeImages

	RightImage isNil
	ifTrue: [ RightImage := (Form fromFileNamed: 'marioR.png')].
	LeftImage isNil
	ifTrue: [ LeftImage := (Form fromFileNamed: 'marioL.png')].
	RightImage2 isNil
	ifTrue: [ RightImage2 := (Form fromFileNamed: 'marioR2.png')].
	LeftImage2 isNil
	ifTrue: [ LeftImage2 := (Form fromFileNamed: 'marioL2.png')].
	UpLeftImage isNil
	ifTrue: [ UpLeftImage := (Form fromFileNamed: 'marioUL.png')].
	UpRightImage isNil
	ifTrue: [ UpRightImage := (Form fromFileNamed: 'marioUR.png')].! !

!JumpingJack methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 21:56'!
interistingMorphs
	|result|
	
	result := OrderedCollection new.
	self displayedMorphs do:
	[:each |
		((self right) > (each left)) & ((self left) < (each right)) & (each top >= self bottom)
			ifTrue:[ result add: each]].
	^ result.! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/15/2010 02:45'!
isInTheAir
	! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/15/2010 02:47'!
isInTheAir: ceil
	^(self bottom = ceil) not.! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/22/2010 04:09'!
isJumping
	^ isJumping! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/15/2010 02:41'!
isJumping: anObject
	isJumping := anObject.
	anObject 
		ifTrue:[self jumpingIndex: 0].! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:37'!
isMovingDown
	^ isMovingDown! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/8/2010 18:07'!
isMovingDown: anObject
	isMovingDown := anObject.
	anObject
		ifTrue:[
			self isMovingUp: false.
			self isJumping: false]! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:37'!
isMovingLeft
	^ isMovingLeft! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/30/2010 17:57'!
isMovingLeft: anObject
	isMovingLeft := anObject.
	anObject
		ifTrue:[self isMovingRight: false]
		ifFalse: [ isMovingRight ifFalse: [
					currentLeftImage := LeftImage.
					self currentImage: currentLeftImage]]! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:37'!
isMovingRight
	^ isMovingRight! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/30/2010 17:57'!
isMovingRight: anObject
	isMovingRight := anObject.
	anObject
		ifTrue:[self isMovingLeft: false]
		ifFalse: [ isMovingLeft ifFalse: [
					currentRightImage := RightImage.
					self currentImage: currentRightImage]]! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:37'!
isMovingUp
	^ isMovingUp! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:53'!
isMovingUp: anObject
	isMovingUp := anObject.
	anObject
		ifTrue:[self isMovingDown: false]! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 7/8/2010 18:11'!
jumping: ceil

	self isJumping 
		ifTrue:[
			self bottom: (self bottom - self distance).
			self incrJumpingIndex.
			self jumpingIndex = 11
				ifTrue: [self isJumping: false]]
		ifFalse:[
				self isMovingUp & self bottom = ceil
					ifTrue:[self isJumping: true]]! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 23:04'!
jumpingIndex
	^ jumpingIndex! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 23:04'!
jumpingIndex: anObject
	jumpingIndex := anObject! !

!JumpingJack methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 22:31'!
keepFocus
	self string keyboardFocusChange: true! !

!JumpingJack methodsFor: 'event handling' stamp: 'BenjaminVanRyseghem 7/4/2010 17:56'!
keyPressed: aKeyString

	aKeyString = '<left>'
		ifTrue:[self isMovingLeft: true].
	aKeyString = '<right>'
		ifTrue:[self isMovingRight: true].
	aKeyString = '<up>'
		ifTrue:[self isMovingUp: true].
	aKeyString = '<down>'
		ifTrue:[self isMovingDown: true].! !

!JumpingJack methodsFor: 'event handling' stamp: 'BenjaminVanRyseghem 7/8/2010 18:01'!
keyReleased: aKeyString

	aKeyString = '<left>'
		ifTrue:[self isMovingLeft: false].
	aKeyString = '<right>'
		ifTrue:[self isMovingRight: false].
	aKeyString = '<up>'
		ifTrue:[self isMovingUp: false].
	aKeyString = '<down>'
		ifTrue:[self isMovingDown: false].! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 7/30/2010 17:53'!
moveLeft

	self isMovingLeft
		ifTrue:[
			self incrRunningIndex.
			self left - self distance > World left 
				ifTrue:  [self right: (self right - self distance)]
				ifFalse: [self left: World left].
			self runningIndex = 2
				ifTrue: [currentLeftImage := LeftImage2].		
			self runningIndex = 4
				ifTrue: [
					self runningIndex: 0.
					currentLeftImage := LeftImage]]..! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 7/30/2010 17:51'!
moveRight

	self isMovingRight
		ifTrue:[
			self incrRunningIndex.
			self right + self distance < World right 
				ifTrue:  [self right: (self right + self distance)]
				ifFalse: [self right: World right].
			self runningIndex = 2
				ifTrue: [currentRightImage := RightImage2].		
			self runningIndex = 4
				ifTrue: [
					self runningIndex: 0.
					currentRightImage := RightImage]].
		! !

!JumpingJack methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 21:54'!
nearestMorph
	|max temp|
	
	temp := self interistingMorphs.
	temp isEmpty
	ifTrue: [^World].
	max := temp first.
	temp do:
	[:each | 
		(each top < max top)
		ifTrue:[max := each]].
	
	^ max.! !

!JumpingJack methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/22/2010 04:09'!
openInWorld
	
	super openInWorld.
	self string isNil
	ifFalse:[	
			self string openInWorld .
			self addMorphBack: (self string)].
		
	^self.! !

!JumpingJack methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/30/2010 18:02'!
reloadImages

	RightImage := nil.
	LeftImage := nil.
	RightImage2 := nil.
	LeftImage2 := nil.
	UpLeftImage := nil.
	UpRightImage := nil.
	self initializeImages .! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/30/2010 17:36'!
runningIndex
	^ runningIndex! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/30/2010 17:36'!
runningIndex: anObject
	runningIndex := anObject! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 7/15/2010 02:49'!
step
	|morph ceil|
	self isMovingDown
		ifTrue: [ 
			self distance: 20]
		ifFalse: [ self distance: 10 ].
	morph := self nearestMorph.	"self halt."
	morph = World
		ifTrue: [ ceil := World bottom ]
		ifFalse: [ ceil := morph top ].
				
	self updateImage: ceil.
	self falling: ceil.
	self moveRight.
	self moveLeft.
	self jumping: ceil.
	! !

!JumpingJack methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/21/2010 23:18'!
stepTime 
	^25.! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:17'!
string
	^ string! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:17'!
string: anObject
	string := anObject! !

!JumpingJack methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 7/30/2010 18:03'!
updateImage: ceil

	(self isInTheAir: ceil)
		ifTrue: [
			self currentImage = currentRightImage | self isMovingRight
				ifTrue: [self currentImage: UpRightImage].
			self currentImage = currentLeftImage | self isMovingLeft
				ifTrue: [self currentImage: UpLeftImage]]
		ifFalse: [
			self currentImage = UpRightImage | self isMovingRight
				ifTrue:  [self currentImage: currentRightImage ].
			self currentImage = UpLeftImage  | self isMovingLeft
				ifTrue:  [self currentImage: currentLeftImage ]]! !

!JumpingJack methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/21/2010 22:19'!
with: aPoint

	self topLeft: aPoint.

! !

Object subclass: #Calc
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-Poland'!

!Calc commentStamp: '<historical>' prior: 0!
Calc execute: '3 4 +'!

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 06:37'!
error

	^ 'An error occured'.! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'sd 7/9/2010 13:29'!
execute2: aString
	|stack newString tmp|
	aString = Calc error
		ifTrue: [^aString].
	stack := (aString subStrings: ' ') asOrderedCollection.
	stack isEmpty
		ifTrue:[^aString].
	stack size = 1
		ifTrue: [
			tmp := self return: stack first.
			Transcript show: tmp;cr.
			^tmp].

	^ self new with: stack; reduceStack.! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'sd 7/9/2010 13:25'!
execute: aString

	|stack newString tmp|
	aString = Calc error 
		ifTrue: [^aString].
	stack := aString subStrings: ' '.
	stack isEmpty ifTrue: [^aString].
	stack size = 1
		ifTrue: [
			tmp := self return: stack first.
			Transcript show: tmp;cr.
			^tmp].
	^ self execute: (self parseStack: stack).! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 12:50'!
findFirstOperator: aStack
	|index|
	index := 1.
	
	[index <= aStack size and: [(aStack at: index) numArgs = -1]]
		whileTrue: [index := index +1].
	
	^index = (aStack size + 1)
		ifTrue: [self error]
		ifFalse: [index]
	! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'sd 7/9/2010 13:18'!
parseStack: aStack
	|index numberOfArguments operator result|
			
	index := self findFirstOperator: aStack.
	index= Calc error
		ifTrue: [^index].
		
	operator := aStack at: index.
	numberOfArguments := 1 + operator numArgs.
	result := ''.
	
	"TO CHANGE"
	(1 to: (index-numberOfArguments-1)) do: [:i| result := result, (aStack at: i), ' '].

	numberOfArguments = 1 & (aStack size >= (numberOfArguments+1))
		ifTrue: [result := result, ((aStack at: index-1) asNumber perform:((aStack at: index) asSymbol)) asString, ' '].

	numberOfArguments > 1 & (aStack size >= (numberOfArguments+1))
		ifTrue: [
			|args|
			args := OrderedCollection new.
			aStack collect: [:each| args add: (each asNumber)] from: index-numberOfArguments+1 to: index-1.
			result := result, ((aStack at: (index-numberOfArguments)) asNumber perform:((aStack at: index) asSymbol) withArguments: (args asArray)) asString, ' ']
		ifFalse: [^Calc error].
	
	(index+1 to: (aStack size)) do: [:i| result := result, (aStack at: i), ' '].

	^ result.
! !

!Calc classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/21/2010 05:29'!
return: aString

	aString numArgs < 1
		ifTrue:[^aString]
		ifFalse: [^self error]
	! !

!Calc methodsFor: 'accessing' stamp: 'sd 7/9/2010 13:31'!
reduceStack
	|index receiver args operator numberOfArgs|
	
	self stack size = 1
		ifTrue: [^self class return: self stack first].
	
	index := self class findFirstOperator: self stack.
	operator := self stack at: index .
	numberOfArgs := 1 + (operator numArgs).
	
	receiver := (self stack at: (index - numberOfArgs)) asNumber.
	args := OrderedCollection new.
	self stack collect: [:each| args add:(each asNumber)] from: (index - numberOfArgs + 1) to: (index - 1).
	
	numberOfArgs = 1
		ifTrue: [ ^ self stack at: index put: (receiver perform: operator asSymbol) asString.]. 
	
	numberOfArgs > 1
		ifTrue: [^ self stack at: index put: (receiver perform: operator asSymbol with: args) first asString].
	self stack collect: [:each| self stack remove:each] from: (index - numberOfArgs + 1) to: (index - 1).
	self stack remove: receiver asString.
	self reduceStack.! !

!Calc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/20/2010 13:08'!
stack
	^ stack! !

!Calc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/20/2010 13:08'!
stack: anObject
	stack := anObject! !

!Calc methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/20/2010 13:08'!
with: aStack

	self stack: aStack.! !

Object subclass: #MorphFire
	instanceVariableNames: 'tableau taille dissipation sleepTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-Morph'!

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 16:53'!
delete
	(1 to: tableau size) do:
	[:i|
		(1 to: (tableau at: 1) size) do:
		[:j|
			((tableau at: i) at: j) delete.
		]
	
	]! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
dissipation
	^ dissipation! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
dissipation: anObject
	dissipation := anObject! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 20:13'!
drawFlame
| blockClosure clockProcess |

blockClosure :=
        [|awakeTime aDelay |
        awakeTime := self sleepTime.

        (tableau size) timesRepeat: 
							[self initColor.
							 self majColor.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:40'!
drawFlame2
| blockClosure clockProcess |
self initColor .
blockClosure :=
        [|awakeTime aDelay |
        awakeTime := self sleepTime.

         (tableau size) timesRepeat: 
							[self majColor2.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:55'!
drawFlames
| blockClosure clockProcess |
blockClosure :=
        [|awakeTime aDelay |
        awakeTime := 2 * self sleepTime.

        (tableau size) timesRepeat: 
							[self drawFlame2.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 19:46'!
initColor
	|ligne median start|
	
	median := (((tableau at:1) size)*0.8)asInteger.
	start := ((tableau at:1) size) - median.
	
	Transcript show: 'start : ', start asString ; cr.
	Transcript show: 'median : ', median asString ; cr.
	
	ligne := tableau at: (tableau size).
	(1 to: start) do:
	[:i|
		(ligne at:i) color:(Color r:( Random new nextValue / 3000000000 -1) g:0 b:0);hide.	
	].
	(start to: median+start) do:
	[:i|
		(ligne at:i) color:(Color r: ( Random new nextValue / 1000000000 -1)g: 0 b:0);hide.	
	].
	(median+start to: ligne size) do:
	[:i|
		(ligne at:i) color:(Color r:( Random new nextValue / 3000000000 -1) g:0 b:0);hide.	
	].! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/14/2010 14:59'!
initialize
	|nblignes nbcolonnes initX initY tempX tempY|

	nblignes := 50.
	nbcolonnes := 100.
	self taille: 1.
	
	initX := 50.
	initY := 50.
	self dissipation: 0.95.
	self sleepTime: 500.
	
	tableau := Array new: nblignes. "colone"
	(1 to: nblignes) do:
	[:i|
		tableau at: i put: (Array new: nbcolonnes).	 "ligne"
	].

	(1 to:  nblignes) do:
	[:col|
		(1 to: nbcolonnes) do:
		[:lig|
			tempX := (initX + (taille*lig)).
			tempY := (initY + (taille*col)).
			(tableau at: col) at: lig put: (Morph new bounds: ((tempX@tempY) corner: (tempX + taille)@ (tempY + taille))).
			((tableau at: col) at: lig) dragEnabled: false;openInWorld.
		]
	]! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/14/2010 14:57'!
majColor
|ligne moy diss seuil|

	seuil := 0.15.

	diss := self dissipation.

	(1 to: tableau size -1) do:
	[:i|
		ligne := tableau at: i.
		"first case"
		moy := ((((tableau at:i+1) at: 1) color red)  + (((tableau at:i+1) at: 2)) color red)/3.
		moy := moy * diss.
		(ligne at: 1) color: (Color r:moy g:0 b:0).
		"last case"
		moy := ((((tableau at:i+1) at: ((tableau at:i+1) size) ) color red)  + (((tableau at:i+1) at: ((tableau at:i+1) size-1))) color red)/3.
		moy := moy * diss.
		(ligne at: (ligne size)) color: (Color r:moy g:0 b:0).
		
		((ligne at:1) color red) +  ((ligne at:1) color blue)  + ((ligne at:1) color green) < seuil
		ifTrue:[(ligne at:1) hide]
		ifFalse:[(ligne at:1)show].
		
		((ligne at:(ligne size)) color red) +  ((ligne at:(ligne size)) color blue) + ((ligne at:(ligne size)) color green) < seuil
		ifTrue:[(ligne at:(ligne size)) hide]
		ifFalse:[(ligne at:(ligne size))show].
		
		(2 to: ligne size-1) do:
		[:j|
			moy := moy := ((((tableau at:i+1) at: j-1) color red)  + (((tableau at:i+1) at: j)) color red) + ((((tableau at:i+1) at: j+1)) color red)/3.
			moy := moy * diss.
			(ligne at: j) color: (Color r:moy g:0 b:0).
			((ligne at:j) color red) +  ((ligne at:j) color blue) + ((ligne at:j) color green) < seuil
		ifTrue:[(ligne at:j) hide]
		ifFalse:[(ligne at:j)show].
		]
	]! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:41'!
majColor2
|ligne moy diss|

	diss := self dissipation.

	(2 to: tableau size -1) do:
	[:i|
		ligne := tableau at: i.
		"first case"
		moy := ((((tableau at:i+1) at: 1) color red)  + (((tableau at:i+1) at: 2) color red) + (((tableau at:i) at: 2) color red) + (((tableau at:i-1) at: 1) color red) + (((tableau at:i-1) at: 2) color red))/8.
		moy := moy * diss.
		(ligne at: 1) color: (Color r:moy g:0 b:0).
		"last case"
		moy := ((((tableau at:i+1) at: ((tableau at:i+1) size) ) color red)  + (((tableau at:i+1) at: ((tableau at:i+1) size-1) ) color red) + (((tableau at:i-1) at: ((tableau at:i-1) size) ) color red)+ (((tableau at:i-1) at: ((tableau at:i-1) size-1) + (((tableau at:i) at: ((tableau at:i) size-1) ) color red)) color red))/8.
		moy := moy * diss.
		(ligne at: (ligne size)) color: (Color r:moy g:0 b:0).
		
		
		(2 to: ligne size-1) do:
		[:j|
			moy := moy := (((((tableau at:i+1) at: j-1) color red)  + (((tableau at:i+1) at: j)) color red) + (((tableau at:i+1) at: j+1) color red) + (((tableau at:i) at: j-1) color red) + (((tableau at:i) at: j+1) color red) + (((tableau at:i-1) at: j-1) color red) + (((tableau at:i-1) at: j) color red)+ (((tableau at:i-1) at: j+1) color red))/8.
			moy := moy * diss.
			(ligne at: j) color: (Color r:moy g:0 b:0).
		]
	]! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:10'!
sleepTime
	^ sleepTime! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:10'!
sleepTime: anObject
	sleepTime := anObject! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/14/2010 14:55'!
step
"|i|
	i isNil
	ifTrue: [i:=0] ifFalse: [i:=i+1]."
	self initColor.
	self majColor.
	"self majColor2."
	"i > 50
	ifTrue:[self majColor2]."! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 15:51'!
stepTime
	^self sleepTime.! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
taille
	^ taille! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
taille: anObject
	taille := anObject! !

Object subclass: #STdoc
	instanceVariableNames: 'class stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-STdoc'!

!STdoc commentStamp: 'BenjaminVanRyseghem 6/10/2010 15:23' prior: 0!
Un STdoc est un simili Javadoc.!

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:46'!
commentsFrom2: aMethod
	"Return the first comment of a method"
	"self commentsFrom2: (Point>>#dist:)"
	^ aMethod methodClass firstCommentAt: aMethod selector.
	
	! !

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:40'!
commentsFrom: aMethod
	"Return the first comment of a method"

	|source result boolWriting boolFirstComment start|
	source := aMethod getSource asString.
	result := ''.
	boolWriting := false.
	boolFirstComment := true.
	start := ((source lineNumber: 1) size +1).
	
	( start to: source size) do:
		[:i|
			(source at: i) = $"
				ifTrue: 
					[
						boolWriting 
							ifTrue: [boolWriting := false]	
							ifFalse: 
							[
								boolFirstComment 
									ifTrue: 
									[
										boolFirstComment := false.
										boolWriting := true.
									]						
							]
					]
				ifFalse: 
					[
						boolWriting
							ifTrue: [result := result, ((source at: i) asString)]
							ifFalse: 
							[
								(source at: i) isSeparator
								ifFalse:
								[
									boolFirstComment := false.
									
								]
							]
					]
		].
	^result withCRs.! !

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:40'!
nameOf: aMethod
	"Return the name of method"
	"self  nameOf: (Point>>#dist:)"
	
	^ aMethod selector
	"
	|source result boolWriting|
	source := (aMethod name subStrings: '>>' ) at: 2.
	result := ''.
	boolWriting := true.
	
	(1 to: source size-1) do:
		[:i|
			((source at: i+1) asString ) = ''
				ifTrue: [boolWriting := false]
				ifFalse: [boolWriting 
								ifTrue: [result := result, ((source at: i) asString)] 
								ifFalse: []
				]
		
		].
	^result. "! !

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:52'!
new

	^ super new initialize ! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/13/2010 15:38'!
build

	self displayHeader.
	self displayInstanceVariables.
	self displayClassVariables.
	self displayInstanceMethods.
	self displayClassMethods. 
	self displaySuperClass. 
	self displaySubClasses.
	^self stream contents! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:09'!
classMethods
	^self myclass class methods.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:37'!
classVariables
	^self myclass classVarNames.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:15'!
comment

	^self myclass class comment.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:23'!
displayClassMethods

	self classMethods isEmpty
		ifFalse: [
			self stream nextPutAll: '----------------------------------------------';cr.
			self stream nextPutAll: 'Mthodes d''instance :';cr.
			self classMethods do: [:each|
				self stream nextPutAll:'     '; nextPutAll:(self class nameOf: each);cr.
				(self class commentsFrom: each) isEmpty
					ifTrue: [ self stream 
									nextPutAll: '     '; 
									nextPutAll:('Just another uncommented method');cr;cr.] 
					ifFalse: [ self stream 
									nextPutAll: '     '; 
									nextPutAll:(self class commentsFrom: each);cr;cr]]].
						
					
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:23'!
displayClassVariables
	
	self classVariables size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------';cr.
		self stream nextPutAll: 'Variables de classe :'; cr.
		self classVariables do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll: each; cr.
		].
	].
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displayHeader
	self stream nextPutAll: self name; cr.
	self stream nextPutAll: self comment;cr;cr.
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displayInstanceMethods

	self instanceMethods size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Mthodes d''instance :'; cr.
		self instanceMethods do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll:(STdoc nameOf: each); cr.
			(STdoc commentsFrom: each) = ''
			ifTrue: 
			[
				self stream nextPutAll: '     '; nextPutAll:('Just another uncommented method');cr;cr.
			] 
			ifFalse: 
			[
				self stream nextPutAll: '     '; nextPutAll:(STdoc commentsFrom: each);cr;cr.
			].
			
		]
	].
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displayInstanceVariables
	
	self instanceVariables size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Variables d''instance :';cr.
		self instanceVariables do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll: each; cr.
		].
	].
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displaySubClasses
	
	self subClasses size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'SubClasses :'; cr.
		"self subClasses do:
		[:each|
			result := result, '     ',each name, String cr.
			result := result, '     ',('Afficher la doc: (STdoc new with: ',each name,';build)'), String cr, String cr.
		]."
		
	].
	^self.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/18/2010 20:24'!
displaySuperClass
	
	self superClass isNil
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Superclass :'; cr.
		self stream nextPutAll: '     '; nextPutAll: (self superClass name); cr.
		"result := result, '     ',('Afficher la doc: (STdoc new with: ',self superClass name,';build)'), String cr, String cr."
	].
	^self.! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/11/2010 16:18'!
export

	self export: ((self name),'.txt').! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/11/2010 16:17'!
export: aString
	|temp|
	temp := self build.
	StandardFileStream 
	fileNamed: aString
	do:[:str|str nextPutAll: temp.]! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:35'!
initialize

stream := WriteStream on: String new.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:22'!
instanceMethods
	^self myclass methodDict values.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:09'!
instanceVariables
	^self myclass instVarNames.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:06'!
myclass
	^ class
! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:25'!
myclass: anObject
"Setter"
	class := anObject! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:13'!
name

	^self myclass name.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:34'!
stream
	^ stream! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:34'!
stream: anObject
	stream := anObject! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:10'!
subClasses
	^self myclass subclasses.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:10'!
superClass
	^self myclass superclass.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:04'!
with: aClass 

class := aClass .! !
Obj initialize!
